// Marker for players (is key pressed or not)
playerKeyboardInput = [new Input(), new Input()];

var tmrGlobal = window.document.getElementById("tmr_global");

/*
 * Left player key down processing
 */
function onKeyDownLeftPlayer(event)
{
    var consumed = true;
/*
    if (event.keyCode === 65) {
        playerKeyboardInput[LEFT_PLAYER].left = 1;
    } else if (event.keyCode === 68) {
        playerKeyboardInput[LEFT_PLAYER].right = 1;
    } else if (event.keyCode === 87) {
        playerKeyboardInput[LEFT_PLAYER].up = 1;
    } else {
        consumed = false;
    }
*/
    if (event.keyCode == 37) {
        playerKeyboardInput[LEFT_PLAYER].left = 1;
    } else if (event.keyCode == 39) {
        playerKeyboardInput[LEFT_PLAYER].right = 1;
    } else if (event.keyCode == 38) {
        playerKeyboardInput[LEFT_PLAYER].up = 1;
    } else {
        consumed = false;
    }
    return consumed;
}

function onKeyUpLeftPlayer(event)
{
    if (event.keyCode == 37) {
        playerKeyboardInput[LEFT_PLAYER].left = 0;
    }
    if (event.keyCode == 39) {
        playerKeyboardInput[LEFT_PLAYER].right = 0;
    }
    if (event.keyCode == 38) {
        playerKeyboardInput[LEFT_PLAYER].up = 0;
    }
}

/*
 * Right player key down processing
 */
function onKeyDownRightPlayer(event)
{
    var consumed = false;
    /*
    if (event.keyCode === 72) {
        playerKeyboardInput[RIGHT_PLAYER].left = 1;
    } else if (event.keyCode === 75) {
        playerKeyboardInput[RIGHT_PLAYER].right = 1;
    } else if (event.keyCode === 85) {
        playerKeyboardInput[RIGHT_PLAYER].up = 1;
    } else {
        consumed = false;
    }
    
    if (event.keyCode === 37) {
        playerKeyboardInput[RIGHT_PLAYER].left = 1;
    } else if (event.keyCode === 39) {
        playerKeyboardInput[RIGHT_PLAYER].right = 1;
    } else if (event.keyCode === 38) {
        playerKeyboardInput[RIGHT_PLAYER].up = 1;
    } else {
        consumed = false;
    }
    */

    return consumed;
}

/*
 * Right player up down processing
 */
function onKeyUpRightPlayer(event)
{
    if (event.keyCode === 72) {
        playerKeyboardInput[RIGHT_PLAYER].left = 0;
    }
    if (event.keyCode === 75) {
        playerKeyboardInput[RIGHT_PLAYER].right = 0;
    }
    if (event.keyCode === 85) {
        playerKeyboardInput[RIGHT_PLAYER].up = 0;
    }
}

window.timerJoystick = null;

function onKeyDown(event)
{
    if (event.keyCode == 116) {
        return location.reload();
    }
    if (!window.gameStart) {
        return false;
    }

    //console.log('onKeyDown ', event);

    var consumed = false;

    // Process keyevent for left player
    //consumed = (onKeyDownLeftPlayer(event) === true) ? true : onKeyDownRightPlayer(event);
    consumed = onKeyDownLeftPlayer(event);
    // If keyevent is not processed, check if it is an event for the gui
    if (consumed === false) {
        stateManager.guiManager.onKeyDown(event);
    }
}

/**
 * Callback for key up events which an player or
 * the gui can consume
 */
function onKeyUp(event)
{
    if (!window.gameStart) {
        return false;
    }
    onKeyUpLeftPlayer(event);
    onKeyUpRightPlayer(event);
}

/**
 * Returns the pressed keys of player
 */
function resetPlayerKeys(player) {
    playerKeyboardInput[player].left = 0;
    playerKeyboardInput[player].right = 0;
    playerKeyboardInput[player].up = 0;
}

/**
 * Returns the pressed keys of all players
 */
function resetKeys() {
    resetPlayerKeys(LEFT_PLAYER);
    resetPlayerKeys(RIGHT_PLAYER);
}

/**
 * Callback called by InputManager
 */
var keyBoardInputCallback = function getKeyboardInput(player)
{
    return playerKeyboardInput[player];
};

/**
 * Return Callback called by InputManager
 */
function createKeyboardInput() {
    resetKeys();
    return keyBoardInputCallback;
}

var KeyboardInput = function (player) {
    this.player = player;

    this.input = keyBoardInputCallback;
};


document.onkeydown = onKeyDown;

document.onkeydown = function(event) {
    if (window.timerJoystick) {
        window.timerJoystick = false;
        tmr_global.removeEventListener('room_game', window.joystickHandler);
        playerKeyboardInput[LEFT_PLAYER].left = 0;
        playerKeyboardInput[LEFT_PLAYER].right = 0;
        playerKeyboardInput[LEFT_PLAYER].up = 0;
    }
    onKeyDown(event);
};

document.onkeyup = function(event) {
    onKeyUp(event);
    //tmr_global.removeEventListener('room_game', window.joystickHandler);
    //tmr_global.addEventListener('room_game', window.joystickHandler);
}

window.addEventHandlerJoystick = function() {
    if (window.timerJoystick) {
        tmr_global.removeEventListener('room_game', window.joystickHandler);
    }
    tmr_global.addEventListener('room_game', window.joystickHandler);
};

window.joystickHandler = function () {
    window.timerJoystick = true;

    if (!window.direction) {
        playerKeyboardInput[LEFT_PLAYER].left = 0;
        playerKeyboardInput[LEFT_PLAYER].right = 0;
        playerKeyboardInput[LEFT_PLAYER].up = 0;
        return;
    }
    var obj1 = {
        keyCode: 0
    }
    if (window.direction == 'right') {
        obj1.keyCode = 39;
        playerKeyboardInput[LEFT_PLAYER].left = 0;
    } else if (window.direction == 'left') {
        obj1.keyCode = 37;
        playerKeyboardInput[LEFT_PLAYER].right = 0;
    } else if (window.direction == 'top') {
        obj1.keyCode = 38;
    } else {
        playerKeyboardInput[LEFT_PLAYER].left = 0;
        playerKeyboardInput[LEFT_PLAYER].right = 0;
        playerKeyboardInput[LEFT_PLAYER].up = 0;
        return;
    }

    onKeyDown(obj1);
}