function onStart() {
    renderManager = new RenderManager;
    
    guiManager = new GUIManager();
    var inputManager = new InputManager();
    var soundManager = new SoundManager();

    stateManager = new StateManager(guiManager, soundManager, inputManager);
    mainLoop();
}

function mainLoop() {
    stateManager.currentState.run();
    setTimeout(mainLoop, DELAY_BETWEEN_FRAMES);
}

if (window.addEventListener) {
    addEventListener("load", onStart, false);

    //var manual = document.window.getElementById('spr_game_snake_manual');
    /*
    manual.addEventListener("click", function( event ) {
        if ((GetCurrentRoom() != 'room_game') || (!gameStart)) {
            return;
        }
        //console.log('event.keyCode: ', event);
        guiManager.onMouseUp(event);
    });
    */

    addEventListener("click", function( event ) {
        if (event.toElement.id == 'spr_game_snake_manual') {
            return guiManager.onMouseUp(event);
        }

        if ((GetCurrentRoom() != 'room_game') || (!gameStart)) {
            return;
        }
        guiManager.onMouseUp(event);
    });
    addEventListener("mousemove", function( event ) {        
    //guiManager.onMouseMove(event);
});
} else {
    attachEvent("onload", onStart);
}
